function F1_mean = F1score(label,class_valid,isprint)
if nargin < 3
    isprint = 0;
end
confu_mat = zeros(4,4);
    for i = 1:numel(label)
        switch label(i)
            case 1
                confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
            case 2
                confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
            case 3
                confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
            case 4
                confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
        end
    end

    F1a=2*confu_mat(1,1)/(sum(confu_mat(1,:))+sum(confu_mat(:,1)));
    F1n=2*confu_mat(2,2)/(sum(confu_mat(2,:))+sum(confu_mat(:,2)));
    F1o=2*confu_mat(3,3)/(sum(confu_mat(3,:))+sum(confu_mat(:,3)));
    F1p=2*confu_mat(4,4)/(sum(confu_mat(4,:))+sum(confu_mat(:,4)));
    F1_mean= (F1n+F1a+F1o)/3;
    F1 = [F1n,F1a,F1o,F1p,F1_mean];

if isprint
    str = ['F1 measure for Normal rhythm:  ' '%1.4f\n'];
    fprintf(str,F1n)
    str = ['F1 measure for AF rhythm:  ' '%1.4f\n'];
    fprintf(str,F1a)
    str = ['F1 measure for other rhythm:  ' '%1.4f\n'];
    fprintf(str,F1o)
    str = ['F1 measure for noise recordings:  ' '%1.4f\n'];
    fprintf(str,F1p)
    str = ['Final F1 measure:  ' '%1.4f\n'];
    fprintf(str,F1_mean)
end