function theta = cjy_em_gmm(data,N)

% EM algorithm to solve Mixed-Gaussian Probleem

% -Input
% - data       The Input data
% - N          The number of Gaussian distribution

% -Ouput
% -theta       The parameter of Mixed Gaussian distribution
%              in accordance with N

% Initialize
[M,L] = size(data); % L is the dimension of feature space
                      % M is the number of samples
theta ={};
cov_cell = cell(N,1);
theta.mean = randn(N,L);
prob = zeros(M,N);
Z = zeros(M,1);
for i = 1:N
    temp = abs(randn(L));
    cov_cell{i} = temp*temp';
end
theta.cov = cov_cell;
max_prob1 = -Inf;
k = 1;
inc = 100;
% E-step: compute the expectation of dual variable
while(abs(inc) > 1e-4 || k < 5)
    for i = 1:N
        prob(:,i) = mvnpdf(data,theta.mean(i,:),theta.cov{i});
    end
    [max_prob_list,Z] = max(prob,[],2);
    max_prob2 = sum(log(max_prob_list));
    fprintf('\nthe %dth round, the probability is %f\n',k,max_prob2);
    inc = (max_prob2-max_prob1)/max_prob2;
    max_prob1 = max_prob2;
    k = k+1;
    
    % M-step: maximum the probability
    for i = 1:N
        theta.mean(i,:) = mean(data(Z == i,:));
        theta.cov{i} = cov(data(Z==i,:));
    end
end
