function [peaks,signs] = cjy_peakfind(signal,thre,debug)
% Find peaks in signal
% Stage1 find all the maximal or minimal
% Stage2 Remove the false peaks using thre

% Input 
% - signal      The input signal
% - thre        Threshold 

% Output
% peaks         The output peaks loc
% sign          imply if it is a max(1) or min(-1)
if nargin < 2
    thre = 10;
    debug = 0;
elseif nargin < 3
    debug = 0;
end

%% find peaks
peaks = [];
signs = [];
for i = 2:numel(signal)-1
    if (signal(i)>signal(i-1) & signal(i) > signal(i+1)) | (signal(i)<signal(i-1) & signal(i) < signal(i+1))
        peaks = [peaks i];
        if  signal(i)>signal(i-1)
            signs = [signs 1];
        else
            signs = [signs -1];
        end
            
    end
end

% Add the bound
peaks = [1 peaks numel(signal)];
signs = [0 signs 0];

%% delete false peak
% if the duration of peak wave is less than the threshold
% the peak is deleted
% 3 is just a threshold, it may vary in different cases
peak_delete = [];
peak_pos = find(signs == 1);
for i = 1:numel(peak_pos)
    if (peaks(peak_pos(i))- peaks(peak_pos(i)-1))+(peaks(peak_pos(i)+1)-peaks(peak_pos(i))) < thre
        peak_delete = [peak_delete peak_pos(i)];
    end
end
peaks(peak_delete) = [];
signs(peak_delete) = [];
%% plot
if debug
    plot(signal)
    hold on
    plot(peaks,signal(peaks),'*');
end