% The pipeline for the Challenge2017
%% Model 1 AFEv+sampent+sd_uqrs -> NN
%{
AFEv = zeros(numel(train_RR),1);
sampent = zeros(numel(train_RR),1);
RR_sd = zeros(numel(train_RR),1);
for i = 1:length(train_RR)
    fprintf('Processing the %d record\n',i);
    RR=train_RR{i}/fs;
    AFEv(i) = comput_AFEv(RR');
    sampent(i) = cjy_feature(RR);
    RR_sd(i) = std(RR);
end

feature = [AFEv,sampent,RR_sd];

% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
y = net(feature');
cjy_valid(net);

save('Model1 AFEv_samp_sd_NN','net');
generateValidationSet
%}
%% Model 2 AFEv+sampent+sd+mask_length -> NN
%{
AFEv = zeros(numel(train_RR),1);
sampent = zeros(numel(train_RR),1);
RR_sd = zeros(numel(train_RR),1);
mask_length = zeros(numel(train_RR),1);
fs = 300;
for i = 1:length(train_RR)
    fprintf('Processing the %d record\n',i);
    RR=train_RR{i}/fs;
    AFEv(i) = comput_AFEv(RR');
    sampent(i) = cjy_feature(RR);
    RR_sd(i) = std(RR);
    mask_length(i) = length(train_mask{i})/length(train_set{i});
end

feature = [AFEv,sampent,RR_sd,mask_length];

% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
y = net(feature');
cjy_valid(net);

save('Model2 AFEv_samp_sd_Mask_NN','net'); % not so good
generateValidationSet
%}


%% Model 3 AFEv+sampent+sd_nn -> NN
%{
AFEv = zeros(numel(train_RR),1);
sampent = zeros(numel(train_RR),1);
RR_sd = zeros(numel(train_RR),1);
for i = 1:length(train_RR)
    fprintf('Processing the %d record\n',i);
    train_RR = diff(train_jqrs{i})/fs;
    RR=train_RR/fs;
    AFEv(i) = comput_AFEv(RR');
    sampent(i) = cjy_feature(RR);
    RR_sd(i) = std(RR);
end

feature = [AFEv,sampent,RR_sd];

% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
y = net(feature');
cjy_valid(net);

save('Model3 AFEv_samp_sd_NN_jqrs','net');
generateValidationSet
%}
%% Model 4 CNN to extract feature (implemented on matlab2017)
%{
load('.\dataset\trainsegset.mat');
train_label = zeros(size(trainsetseg,1),1);
train_label(trainsetseg_label == 'A') = 1;
train_label(trainsetseg_label == 'N') = 2;
train_label(trainsetseg_label == 'O') = 3;
train_label(trainsetseg_label == '~') = 4;

trainsetseg = reshape(trainsetseg',[1 750 1 size(trainsetseg,1)]);
layers = [imageInputLayer([1 750 1])
convolution2dLayer([1,150],5)
reluLayer
maxPooling2dLayer([1,6],'Stride',[1,6])
fullyConnectedLayer(4)
softmaxLayer
classificationLayer()];
options = trainingOptions('sgdm','MaxEpochs',15, ...
'InitialLearnRate',0.0001);
train_label = categorical(train_label);
convnet = trainNetwork(trainsetseg,train_label,layers,options);

% valid
load('.\dataset\validsegset.mat');
validsetseg = reshape(validsetseg',[1 750 1 size(validsetseg,1)]);

Ytest = classify(convnet,validsetseg);
valid_label = zeros(size(validsetseg,1),1);
valid_label(validsetseg_label == 'A') = 1;
valid_label(validsetseg_label == 'N') = 2;
valid_label(validsetseg_label == 'O') = 3;
valid_label(validsetseg_label == '~') = 4;
valid_label = categorical(valid_label);

acc = sum(valid_label == Ytest')/numel(valid_label);
fprintf("%f\n",acc); %to be continued
%}
%% Model 5 sampent + AFEv + RRsd + kportion + 
   % mean max mean median norm mse
%{
feature = zeros(numel(train_set),14);
fs = 300;
for i = 1:length(train_set)
    fprintf('Processing the %d record\n',i);
    feature(i,:) = cjy_feature(train_set{i},train_uqrs{i},train_RR{i},fs);
end


% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
cjy_valid(net);
save('.\Model\Model3 1+mse_NN.mat','net');
%}
%generateValidationSet
%% Model 6 the total template in using CNN
%{
load('.\result\result318_wave_normmse.mat');
load('.\dataset\trainset.mat');
L = 301;
m = numel(train_wave);
wave_temp = zeros(m,L);
for i = 1:m
   fprintf("Processing %d\n",i);
   wave = train_wave{i};
   [k,C,ksum,D] = kmeans(wave,2);
   mse = zeros(1,numel(k));
   k_max = mode(k);
   wave_temp(i,:) = C(k_max,:);
end
train_cate = zeros(m,4);
train_cate(train_label == 'A') = 1;
train_cate(train_label == 'N') = 2;
train_cate(train_label == 'O') = 3;
train_cate(train_label == '~') = 4;

wave_temp = reshape(wave_temp',[1 L 1 m]);
layers = [imageInputLayer([1 L 1])
convolution2dLayer([1,10],5)
reluLayer
maxPooling2dLayer([1,4],'Stride',[1,4])
convolution2dLayer([1,10],5)
reluLayer
maxPooling2dLayer([1,4],'Stride',[1,4])
fullyConnectedLayer(4)
softmaxLayer
classificationLayer()];
options = trainingOptions('sgdm','MaxEpochs',100, ...
'InitialLearnRate',0.0001);
train_cate = categorical(train_cate);
convnet = trainNetwork(wave_temp,train_cate,layers,options);

valid
load('.\dataset\validsegset.mat');
validsetseg = reshape(validsetseg',[1 750 1 size(validsetseg,1)]);

Ytest = classify(convnet,validsetseg);
valid_label = zeros(size(validsetseg,1),1);
valid_label(validsetseg_label == 'A') = 1;
valid_label(validsetseg_label == 'N') = 2;
valid_label(validsetseg_label == 'O') = 3;
valid_label(validsetseg_label == '~') = 4;
valid_label = categorical(valid_label);

acc = sum(valid_label == Ytest')/numel(valid_label);
fprintf("%f\n",acc); %to be continued

% not so good
%}
%% Model 7 RWE+ all above
%{
feature = zeros(numel(train_set),14);
fs = 300;
for i = 1:length(train_set)
    fprintf('Processing the %d record\n',i);
    feature(i,:) = cjy_feature(train_set{i},train_uqrs{i},train_RR{i},fs);
end

% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
cjy_valid(net);
save('Model4 3+RWE.mat','net');
generateValidationSet
%}
%% Model 8 also RWE but not with modwt, just go with dwt
%{
feature = zeros(numel(train_set),14);
fs = 300;
for i = 1:length(train_set)
    fprintf('Processing the %d record\n',i);
    feature(i,:) = cjy_feature(train_set{i},train_uqrs{i},train_RR{i},fs);
end

% change the label
label_mat = zeros(numel(train_set),4);
label_mat(train_label == 'N',1) = 1;
label_mat(train_label == 'A',2) = 1;
label_mat(train_label == 'O',3) = 1;
label_mat(train_label == '~',4) = 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat');
cjy_valid(net);
save('Model5 3+RWE_wavedec.mat','net');
generateValidationSet
%}
%% Model 9 model8+Stephen's 8 features and Heba's feature

feature = zeros(numel(signal),23);
fs = 300;
for i = 1:length(signal)
    fprintf('Processing the %d record\n',i);
    feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
end

% change the label
label_mat = zeros(numel(signal),1);
label_mat(label == 'N',1) = 1;
label_mat(label == 'A',2) = 1;  
label_mat(label == 'O',3) = 1;
label_mat(label == '~',4) = 1;

% adjusting the weight;
ew = ones(1,numel(signal));
ew(label == '~')= 2;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig

net = train(net,feature',label_mat',[],[]);

[vlabel,vpred] = cjy_valid(net);
save('Model8 7+hfmean.mat','net');


vpred(vpred == 1) = 'N';
vpred(vpred == 2) = 'A';
vpred(vpred == 3) = 'O';
vpred(vpred == 4) = '~';
wrongid = find(vpred' ~= vlabel);
f = fopen('wrongid_valid.txt','w+');
for i = 1:numel(wrongid)
    fprintf(f,"%s  %s  %s\n",num2str(wrongid(i)),vlabel(wrongid(i)),char(vpred(wrongid(i))));
end
fclose(f);
signal = signal(wrongid);
uqrs = uqrs(wrongid);
wave = wave(wrongid);
label = label(wrongid);
index = index(wrongid);
RR = RR(wrongid);
mask = mask(wrongid);
save('.\dataset\wrongset_valid.mat','signal','uqrs','wave','label','index','RR','mask');

% write Nwrong

idN = find((vlabel == 'N' | vpred' == 'N')==1);
f = fopen('Nwrong.txt','w+');
for i = 1:numel(idN)
    fprintf(f,"%d %s %s\n",idN(i),vlabel(idN(i)),vpred(idN(i)));
end
fclose(f);


generateValidationSet
%% Model 10 neural network for N and non-N
load('.\dataset\trainset.mat');
feature = zeros(numel(signal),23);
fs = 300;
for i = 1:length(signal)
    fprintf('Processing the %d record\n',i);
    feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
end

% change the label
label_mat = zeros(numel(signal),1);
label_mat(label == 'N') = 1;
label_mat(label == 'A') = 0;
label_mat(label == 'O') = 0;
label_mat(label == '~') = 0;

% adjusting the weight;
%ew = ones(1,numel(signal));
%ew(label == '~')= 1;

% build the feedforward network
net = patternnet([10,10]);
net.PerformFcn = 'crossentropy'; 
net.trainFcn = 'trainlm';
net.performParam.regularization = 0;
net.layers{1}.transferFcn = 'logsig'; % logsig
net = train(net,feature',label_mat',[],[]);

load('.\dataset\validset.mat');
feature = zeros(numel(RR),23);
for i = 1:length(RR)
    fprintf('Valid: Processing the %d record\n',i);
    feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
end
pre = net(feature');
label_mat = (label == 'N');
pred = pre>0.5;
id_n = find(pred' ~= label_mat);
%}
%% How about using convolution network for training (not so good)
load('.\dataset\trainset.mat');
fs = 300;
label_mat = zeros(size(signal,1),4);
label_mat(label == 1, 1) = 1;
label_mat(label == 2, 2) = 1;
label_mat(label == 3, 3) = 1;
label_mat(label == 4, 4) = 1;

% build the cnn
trainsetseg = reshape(feature',[1 30 1 size(feature,1)]);
layers = [imageInputLayer([1 30 1])
convolution2dLayer([1,5],5)
reluLayer
maxPooling2dLayer([1,2],'Stride',[1,2])
fullyConnectedLayer(4)
softmaxLayer
classificationLayer()];
options = trainingOptions('sgdm','MaxEpochs',100, ...
'InitialLearnRate',0.0001);
train_label = categorical(cellstr(label));
convnet = trainNetwork(trainsetseg,train_label,layers,options);
% bad
%% How abot svm (not so good)
feature = feature(:,1:23);
model = fitcsvm(feature,label_mat);
pre = predict(model,feature);
sum(pre ~= label_mat)/numel(pre);
%% How about random forest trees
B = TreeBagger(50,feature,label_mat,'OOBPrediction','On',...
    'Method','classification');
view(B.Trees{1},'Mode','graph')
pred = cell2mat(predict(B,feature));
pred = (pred == '1');
sum(pred ~= label_mat)
%}
%% Try simple emsemble algorithm + 25 feature
load('.\dataset\trainset.mat');
% feature = zeros(numel(signal),25);
% for i = 1:length(signal)
%     fprintf('Processing the %d record\n',i);
%     feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
% end
M = 4000; % number of training numbers in Emsemble NN
N = 10; % build ten classifier
Np = 0.4*M;
Ap = 0.18*M;
Op = 0.36*M;
np = 0.06*M;


id_N = randi(sum(label == 'N'),[N,Np]);
id_A = randi(sum(label == 'A'),[N,Ap]);
id_O = randi(sum(label == 'O'),[N,Op]);
id_n = randi(sum(label == '~'),[N,np]);

label_sub = [ones(Np,1);2*ones(Ap,1);3*ones(Op,1); 4*ones(np,1)];
label_mat = zeros(M,4);

label_mat(label_sub == 1, 1) = 1;
label_mat(label_sub == 2, 2) = 1;
label_mat(label_sub == 3, 3) = 1;
label_mat(label_sub == 4, 4) = 1;

ID_N = find(label == 'N');
ID_A = find(label == 'A');
ID_O = find(label == 'O');
ID_n = find(label == '~');

for i = 1:10
    total_ID = [ID_N(id_N(i,:)); ID_A(id_A(i,:)) ;ID_O(id_O(i,:)) ;ID_n(id_n(i,:))];
    feature_sub = feature(total_ID,:);
    net{i} = patternnet([10,10]);
    net{i}.PerformFcn = 'crossentropy'; 
    net{i}.trainFcn = 'trainlm';
    net{i}.performParam.regularization = 0;
    net{i}.layers{1}.transferFcn = 'logsig'; % logsig
    ew = ones(1,M);
    ew(label == '~')= 2;
    net{i} = train(net{i},feature_sub',label_mat',[],[]);
end

load('.\dataset\validset.mat');
% feature_valid = zeros(numel(signal),30);
% % for i = 1:length(signal)
% %     fprintf('Processing the %d record\n',i);
% %     feature_valid(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
% % end

pred = zeros(size(feature,1),10);
for i = 1:10
    prob = net{i}(feature');
    [~,pred(:,i)] = max(prob);
end
class_valid = mode(pred,2);

    confu_mat = zeros(4,4);
    for i = 1:numel(label)
        switch label(i)
            case 'N'
                confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
            case 'A'
                confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
            case 'O'
                confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
            case '~'
                confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
        end
    end

    F1n=2*confu_mat(1,1)/(sum(confu_mat(1,:))+sum(confu_mat(:,1)));
    F1a=2*confu_mat(2,2)/(sum(confu_mat(2,:))+sum(confu_mat(:,2)));
    F1o=2*confu_mat(3,3)/(sum(confu_mat(3,:))+sum(confu_mat(:,3)));
    F1p=2*confu_mat(4,4)/(sum(confu_mat(4,:))+sum(confu_mat(:,4)));
    F1=(F1n+F1a+F1o+F1p)/4;


    str = ['F1 measure for Normal rhythm:  ' '%1.4f\n'];
    fprintf(str,F1n)
    str = ['F1 measure for AF rhythm:  ' '%1.4f\n'];
    fprintf(str,F1a)
    str = ['F1 measure for other rhythm:  ' '%1.4f\n'];
    fprintf(str,F1o)
    str = ['F1 measure for noise recordings:  ' '%1.4f\n'];
    fprintf(str,F1p)
    str = ['Final F1 measure:  ' '%1.4f\n'];
    fprintf(str,F1)

%% Add two Poincare std
