function [label,class_valid] = cjy_valid(net)

% validate the model's performance on
% the unseen 50% data

% validset.mat include
% valid_label   1*4648 char label - 'A', 'O', 'N', '~'
% valid_mask    1*4648 cell mask
% valid_RR      1*4648 cell RR series
% valid_set     1*4648 cell original signal
% valid_uqrs    1*4648 cell R peak locations


load('.\dataset\validset.mat');
fs = 300;

%% Model 8 AFEv+sampent+sd -> Neural Network
feature = zeros(numel(RR),23);
for i = 1:length(RR)
    fprintf('Valid: Processing the %d record\n',i);
    feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
end

vlabel_mat = zeros(numel(label),4);
vlabel_mat(label == 'N',1) = 1;
vlabel_mat(label == 'A',2) = 1;
vlabel_mat(label == 'O',3) = 1;
vlabel_mat(label == '~',4) = 1;

y_valid = net(feature');
[~,class_valid] = max(y_valid);
figure, plotconfusion(vlabel_mat',y_valid);

confu_mat = zeros(4,4);

for i = 1:numel(signal)
    switch label(i)
        case 'N'
            confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
            confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
            confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
            confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
        case 'A'
            confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
            confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
            confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
            confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
        case 'O'
            confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
            confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
            confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
            confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
        case '~'
            confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
            confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
            confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
            confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;

    end
end

F1n=2*confu_mat(1,1)/(sum(confu_mat(1,:))+sum(confu_mat(:,1)));
F1a=2*confu_mat(2,2)/(sum(confu_mat(2,:))+sum(confu_mat(:,2)));
F1o=2*confu_mat(3,3)/(sum(confu_mat(3,:))+sum(confu_mat(:,3)));
F1p=2*confu_mat(4,4)/(sum(confu_mat(4,:))+sum(confu_mat(:,4)));
F1=(F1n+F1a+F1o+F1p)/4;


str = ['F1 measure for Normal rhythm:  ' '%1.4f\n'];
fprintf(str,F1n)
str = ['F1 measure for AF rhythm:  ' '%1.4f\n'];
fprintf(str,F1a)
str = ['F1 measure for Other rhythm:  ' '%1.4f\n'];
fprintf(str,F1o)
str = ['F1 measure for Noisy recordings:  ' '%1.4f\n'];
fprintf(str,F1p)
str = ['Final F1 measure:  ' '%1.4f\n'];
fprintf(str,F1)

