function F1 = nntest

load('.\dataset\trainset.mat');
% for i = 1:length(signal)
%     fprintf('Processing the %d record\n',i);
%     feature(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
% end

M = 4000; % number of training numbers in Emsemble NN
N = 10; % build ten classifier
Np = 0.4*M;
Ap = 0.18*M;
Op = 0.36*M;
np = 0.06*M;

id_N = randi(sum(label == 'N'),[N,Np]);
id_A = randi(sum(label == 'A'),[N,Ap]);
id_O = randi(sum(label == 'O'),[N,Op]);
id_n = randi(sum(label == '~'),[N,np]);

label_sub = [ones(Np,1);2*ones(Ap,1);3*ones(Op,1); 4*ones(np,1)];
label_mat = zeros(M,4);

label_mat(label_sub == 1, 1) = 1;
label_mat(label_sub == 2, 2) = 1;
label_mat(label_sub == 3, 3) = 1;
label_mat(label_sub == 4, 4) = 1;

ID_N = find(label == 'N');
ID_A = find(label == 'A');
ID_O = find(label == 'O');
ID_n = find(label == '~');

for i = 1:10
    total_ID = [ID_N(id_N(i,:)); ID_A(id_A(i,:)) ;ID_O(id_O(i,:)) ;ID_n(id_n(i,:))];
    feature_sub = feature(total_ID,:);
    net{i} = patternnet([10,10]);
    net{i}.PerformFcn = 'crossentropy'; 
    net{i}.trainFcn = 'trainlm';
    net{i}.performParam.regularization = 1;
    net{i}.layers{1}.transferFcn = 'logsig'; % logsig
    ew = ones(1,M);
    ew(label == '~')= 2;
    net{i} = train(net{i},feature_sub',label_mat',[],[]);
end

load('.\dataset\validset.mat');
% for i = 1:size(feature_valid,1)
%     fprintf('Processing the %d record\n',i);
%     feature_valid(i,:) = cjy_feature(signal{i},uqrs{i},RR{i},fs);
% end

pred = zeros(size(feature,1),10);
for i = 1:10
    prob = net{i}(feature');
    [~,pred(:,i)] = max(prob);
end
class_valid = mode(pred,2);

confu_mat = zeros(4,4);
for i = 1:numel(label)
    switch label(i)
        case 'N'
            confu_mat(1,class_valid(i)) = confu_mat(1,class_valid(i))+1;
        case 'A'
            confu_mat(2,class_valid(i)) = confu_mat(2,class_valid(i))+1;
        case 'O'
            confu_mat(3,class_valid(i)) = confu_mat(3,class_valid(i))+1;
        case '~'
            confu_mat(4,class_valid(i)) = confu_mat(4,class_valid(i))+1;
    end
end

F1n=2*confu_mat(1,1)/(sum(confu_mat(1,:))+sum(confu_mat(:,1)));
F1a=2*confu_mat(2,2)/(sum(confu_mat(2,:))+sum(confu_mat(:,2)));
F1o=2*confu_mat(3,3)/(sum(confu_mat(3,:))+sum(confu_mat(:,3)));
F1p=2*confu_mat(4,4)/(sum(confu_mat(4,:))+sum(confu_mat(:,4)));
F1=(F1n+F1a+F1o+F1p)/4;


str = ['F1 measure for Normal rhythm:  ' '%1.4f\n'];
fprintf(str,F1n)
str = ['F1 measure for AF rhythm:  ' '%1.4f\n'];
fprintf(str,F1a)
str = ['F1 measure for other rhythm:  ' '%1.4f\n'];
fprintf(str,F1o)
str = ['F1 measure for noise recordings:  ' '%1.4f\n'];
fprintf(str,F1p)
str = ['Final F1 measure:  ' '%1.4f\n'];
fprintf(str,F1)
